local core = minetest

local modstorage = core.get_mod_storage()
local modpath = core.get_modpath("factions")
local party_class = dofile(modpath .. "/party.lua")

factions = party_api.manager_classes.invite_manager({
    storage_ref = modstorage,
    party_class = party_class
})

factions.update_nametag = function (player_or_playername, partyname, color)
    local player = player_or_playername
    local playername = player_or_playername
    local player = type(player) == "string" and core.get_player_by_name(player) or player
    if not core.is_player(player) then
        return false, "Could not find player"
    end
    if type(playername ~= "string") then
        playername = player:get_player_name()
    end

    local text = playername
    if partyname and partyname ~= "" then
        color = color or "#fff"
        text = string.format("%s %s", core.colorize(color, string.format("[%s]", partyname)), playername)
    end

    player:set_nametag_attributes({
        text = text
    })

    return "OK"
end

core.register_on_joinplayer(function (player)
    local playername = player:get_player_name()
    local partyname = factions:getPlayersParty(playername)
    print("abc")

    if partyname ~= "" then
        print("def")
        local party = factions:getParty(partyname)
        -- local party, error = factions:getParty(partyname)
        if not party then return end -- TODO: log error
        print("fgh")
        local color = party.color
        factions.update_nametag(player, partyname, color)
    end
end)