local super = party_api.party_classes.invite_party
local Party = setmetatable({}, {__index = super})

Party.getData = function(self)
    local result = super.getData(self)
    result.color = self.color
    return result
end

Party.delete = function (self)
    local sucess, error = super.delete(self)
    if not sucess then return false, error end

    for member, _ in pairs(self.members) do
        factions.update_nametag(member, "")
    end
    return "OK"
end

Party.rename = function(self, newname)
    local success, error = super.rename(self, newname)
    if not success then return false, error end

    for member, _ in pairs(self.members) do
        factions.update_nametag(member, newname, self.color)
    end

    return "OK"
end

Party.join = function (self, playername)
    local sucess, error = super.join(self, playername)
    if not sucess then return false, error end

    factions.update_nametag(playername, self.name, self.color)

    return "OK"
end

Party.leave = function (self, playername)
    local sucess, error = super.leave(self, playername)
    if not sucess then return false, error end

    factions.update_nametag(playername, "")

    return "OK"
end

Party.load = function (...)
    local party = super.load(...)
    return setmetatable(party, {__index = Party})
end

Party.create = function(...)
    local party = super.create(...)
    party.color = "#fff"
    return setmetatable(party, {__index = Party})
end

return Party