local InvitePartyManager = {}

local super = party_api.manager_classes.default_manager
local __index = function (_, key)
    return InvitePartyManager[key] or super[key]
end

InvitePartyManager.setInvite = function (self, partyname, value)
    local party, error = self:getParty(partyname)
    if not party then return false, error end

    local success, error = party:setInviteRequired(value)
    if not success then return false, error end
    self:setParty(party)
    return success
end

InvitePartyManager.invite = function (self, playername, partyname)
    local party, error = self:getParty(partyname)
    if not party then return false, error end
    local sucess, error = party:invite(playername)
    if not sucess then return false, error end
    self:setParty(party)
    return "OK"
end

InvitePartyManager.cancelInvite = function (self, playername, partyname)
    local party, error = self:getParty(partyname)
    if not party then return false, error end
    local sucess, error = party:cancelInvite(playername)
    if not sucess then return false, error end
    self:setParty(party)
    return "OK"
end


local call = function (_, ...)
    local manager = super(...)
    return setmetatable(manager, {__index = __index})
end

return setmetatable({}, {
    __call = call,
    __index = __index,
})